unit AutoClose;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

type
  TAutoClose = class(TComponent)
  private
    { Private declarations }
    FEnabled: Boolean;
    FTimer: TTimer;
    FOnTimer: TNotifyEvent;

    procedure NewTimer(Sender: TObject);
    function GetInterval: Cardinal;
    procedure SetEnabled(const Value: Boolean);
    procedure SetInterval(const Value: Cardinal);
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

  published
    { Published declarations }
    property Enabled: Boolean read FEnabled write SetEnabled;
    property Interval: Cardinal read GetInterval write SetInterval;
    property OnTimer: TNotifyEvent read FOnTimer write FOnTimer;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Samples', [TAutoClose]);
end;

{ TAutoClose }

constructor TAutoClose.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FTimer := TTimer.Create(Self);
  FTimer.Enabled := False;
  FTimer.OnTimer := NewTimer;
end;

destructor TAutoClose.Destroy;
begin

  FreeAndNil(FTimer);
  inherited Destroy;
end;

function TAutoClose.GetInterval: Cardinal;
begin
  Result := FTimer.Interval;
end;

procedure TAutoClose.SetEnabled(const Value: Boolean);
begin
  FEnabled := Value;
  // Twb Run Time ɤ~@
  if not (csDesigning in ComponentState) then
    FTimer.Enabled := Value;
end;

procedure TAutoClose.SetInterval(const Value: Cardinal);
begin
  FTimer.Interval := Value;
end;

procedure TAutoClose.NewTimer(Sender: TObject);
begin
  Enabled := False;  // N FTimer קKĲo

  // pG OnTimer {h
  if Assigned(FOnTimer) then
    FOnTimer(Sender);
    
  (Owner as TForm).Close;
end;

end.
